Description

I'm running Foreman 1.14.3 and have an issue with host parameters not available in user_data template.

In the template I have:

<%= @host.params['myparam'] %>

 On the host creation page, in the parameter tab, I add a host param 'myparam' with value 'test'.

Once the host is created, the 'Preview' template correctly shows the param value.

But the generated template on the target machine (in /var/lib/cloud..) does not contain the param value (it is empty).

If I set the parameter on hostgroup or subnet then it works as expected.

The problem is only with params at host level.

Related issues:

Related to Foreman - Bug #19465: User data template rendering does not render... New

Related to Foreman - Bug #23104: Host parameters not available in foreman_hooks Need more information

Related to Foreman - Bug #21618: hostgroup parameter does not show up in the ... New 11/09/2017

Related to Foreman - Bug #21552: Host parameters added/updated via API do not... New 11/01/2017

History

#1 - 06/20/2017 12:06 PM - Tyler Gregory

This is probably related to #19465

#2 - 06/20/2017 12:37 PM - Anthony Chevalet

Yes it seems so, in my case the preview does render the parameter

#3 - 06/30/2017 09:34 AM - Marek Hulán

- Status changed from New to Need more information

Are you using organizations or locations? Could you update to 1.15 and retest?

#4 - 06/30/2017 09:34 AM - Marek Hulán

- Related to Bug #19465: User data template rendering does not render host parameters added

#5 - 06/30/2017 10:30 AM - Anonymous

Yes I'm using organizations and locations.

I will upgrade to 1.15 and let you know.

#6 - 08/10/2017 02:44 PM - Anthony Chevalet
Same behaviour with 1.15.3 and the new syntax

host_param('param_name')

#7 - 10/25/2017 05:39 PM - Dis McCarthy

Same here with 1.15.6-1. Safemode is off, render template shows the variables correctly but the actual userdata sent to the instance doesn't.

Has anyone found a workaround yet?

#8 - 10/25/2017 06:43 PM - Anthony Chevalet

My workaround is to use a tmp hostgroup at host creation...

#9 - 10/25/2017 06:47 PM - Anthony Chevalet

- Status changed from Need more information to New

#10 - 01/03/2018 09:53 PM - Marek Hulán

By rendering the template you mean preview the render while editing it? It might be caused by the fact that when the template is rendered for the

host, different, system user account is used.

#11 - 01/03/2018 10:16 PM - Anthony Chevalet

Yes, the preview while editing templates OR the 'Review' template on the host page (once created) show the parameter.

#12 - 04/27/2018 02:05 PM - Anthony Chevalet

- Related to Bug #23104: Host parameters not available in foreman_hooks  added

#13 - 04/27/2018 02:17 PM - Anthony Chevalet

- Related to Bug #21618: hostgroup parameter does not show up in the PXE template added

#14 - 04/27/2018 02:18 PM - Anthony Chevalet

- Related to Bug #21552: Host parameters added/updated via API do not make it to userscript on provisioning to EC2 added

#15 - 08/29/2018 10:31 PM - Anthony Chevalet

Still valid for 1.19RC3 ;)

#16 - 08/30/2018 01:21 AM - Anonymous

- Found in Releases 1.19.0-RC3 added

#17 - 08/30/2018 02:11 PM - Anthony Chevalet

- Subject changed from Host parameter not working in provisioning template  to Host parameter not rendered in user_data template 

As a precision, it impacts only user_data templates. Parameters are correctly rendered in Finish templates.

#18 - 09/25/2018 12:11 AM - xioabin qu

We're using PXELinux template, and is also impacted.

#19 - 11/30/2018 12:53 PM - Ondrej Vesely

Found also in 1.19.1-1.el7.

Affects Provisioning template, Finish template and PXELinux template.

#20 - 11/30/2018 04:14 PM - Ondrej Vesely

- Found in Releases 1.19.1 added

- Found in Releases deleted (1.14.3, 1.19.0-RC3)

I have upgraded to 1.20.0-1.el7 and the bug is there too.

#21 - 11/30/2018 04:17 PM - Ondrej Vesely

- Found in Releases 1.15.3, 1.19.0-RC3, 1.20.0 added
#22 - 08/06/2019 01:21 PM - Anthony Chevalet

- Found in Releases 1.21.3 added

still valid with 1.21.3
